SystemOrganization addCategory: #'P4-Kernel-Memory'!
SystemOrganization addCategory: #'P4-Kernel-Collection'!
SystemOrganization addCategory: #'P4-Kernel-Package'!
SystemOrganization addCategory: #'P4-Kernel-Object'!
SystemOrganization addCategory: #'P4-Kernel-Behavior'!
SystemOrganization addCategory: #'P4-Kernel-Callable'!
SystemOrganization addCategory: #'P4-Kernel-Boolean'!
SystemOrganization addCategory: #'P4-Kernel-Structure'!
SystemOrganization addCategory: #'P4-Kernel-Number'!
SystemOrganization addCategory: #'P4-Kernel-String'!
SystemOrganization addCategory: #'P4-Kernel-IO'!
SystemOrganization addCategory: #'P4-Kernel-Exception'!

Object subclass: #P4Object
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Object'!

P4Object class
	instanceVariableNames: 'pname'!

P4Object class
	instanceVariableNames: 'pname'!

P4Object subclass: #P4AbstractPackage
	instanceVariableNames: 'members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Package'!

!P4AbstractPackage class methodsFor: 'pharo package loading' stamp: 'OliFlueckiger 7/25/2011 17:03'!
packageOfClass: aClass
	| path |
	path := '-' split: aClass category.
	path removeFirst.
	path := path collect: #asSymbol.
	^ P4RootPackage ensurePath: path! !

!P4AbstractPackage methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 17:23'!
addClass: aName
	<preventExport>
	| reference |
	self flag: 'ne'.
	reference := members at: aName ifAbsentPut: [ |class superclass|
		class := P4PharoClass new
					name: aName.
		P4ClassReference new cls: class; package: self ].
	^ reference cls.! !

!P4AbstractPackage methodsFor: 'accessing' stamp: 'OliFlueckiger 7/20/2011 17:13'!
at: aName ifAbsent: aBlock
	^ (members at: aName ifAbsent: [ ^ aBlock value ]) cls! !

!P4AbstractPackage methodsFor: 'iterating' stamp: 'ToonVerwaest 5/16/2011 23:07'!
classesDo: action 
	members do: [ :member | member classesDo: action ]! !

!P4AbstractPackage methodsFor: 'iterating' stamp: 'OliFlueckiger 7/6/2011 16:10'!
dumpGlobalOn: binaryOut
	^ self dumpOn: binaryOut! !

!P4AbstractPackage methodsFor: 'iterating' stamp: 'OliFlueckiger 7/6/2011 16:10'!
dumpLocalOn: binaryOut
	^ binaryOut postpone: self  ! !

!P4AbstractPackage methodsFor: 'package creation' stamp: 'ToonVerwaest 7/18/2011 22:33'!
ensurePackage: aPackageName
	<preventExport>
	self flag: 'ne'.
	^ members at: aPackageName ifAbsentPut: [
		P4Package new name: aPackageName; parent: self ]! !

!P4AbstractPackage methodsFor: 'accessing' stamp: 'OliFlueckiger 7/11/2011 15:15'!
flush
	members := nil! !

!P4AbstractPackage methodsFor: 'initialize-release' stamp: 'ToonVerwaest 7/18/2011 22:34'!
initialize
	<preventExport>
	self flag: 'ne'.
	members := P4IdentityDictionary new! !

!P4AbstractPackage methodsFor: 'testing' stamp: 'ToonVerwaest 5/16/2011 18:40'!
isRootPackage
	^ false! !

!P4AbstractPackage methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 17:38'!
packageAt: aSymbol
	^ members at: aSymbol ifAbsent: [ "no such member" self halt ]! !

!P4AbstractPackage methodsFor: 'iterating' stamp: 'ToonVerwaest 7/19/2011 13:45'!
packagesDo: action 
	action value: self.
	members do: [ :member | member packagesDo: action ]! !

!P4AbstractPackage methodsFor: 'iterating' stamp: 'OliFlueckiger 7/15/2011 13:41'!
printOn: aStream 
	aStream! !

P4AbstractPackage subclass: #P4Package
	instanceVariableNames: 'parent name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Package'!

!P4Package class methodsFor: 'instance creation' stamp: 'ToonVerwaest 5/17/2011 02:56'!
byPathName: aName
	| segments |
	segments := ('.' split: aName) collect: #asSymbol.
	^ P4RootPackage resolve: segments
	! !

!P4Package class methodsFor: 'pharo package loading' stamp: 'ToonVerwaest 7/21/2011 17:19'!
loadClass: aClass
	| package |
	aClass ifNil: [ ^ nil ].
	package := self packageOfClass: aClass.
	^ package at: aClass pname ifAbsent: [
		(package addClass: aClass pname)   
			superclass: (P4Package loadClass: aClass p4super);
			inPharo: aClass;
			metaclass: aClass p4class]! !

!P4Package class methodsFor: 'pharo package loading' stamp: 'OliFlueckiger 7/5/2011 15:51'!
loadClasses
	P4RootPackage flushPackages.! !

!P4Package class methodsFor: 'pharo package loading' stamp: 'OliFlueckiger 7/25/2011 17:03'!
packageOfClass: aClass
	| path |
	path := '-' split: aClass theNonMetaClass category.
	path removeFirst.
	path := path collect: #asSymbol.
	^ P4RootPackage ensurePath: path! !

!P4Package methodsFor: 'filesystem' stamp: 'ToonVerwaest 7/18/2011 21:53'!
ensureDirectory
	<preventExport>
	| parentDir |
	parentDir := parent ensureDirectory.
	(parentDir directoryExists: name) ifFalse: [ parentDir createDirectory: name ].
	^ parentDir directoryNamed: name.
	! !

!P4Package methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:58'!
name
	^ name
! !

!P4Package methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:58'!
name: anObject
	name := anObject! !

!P4Package methodsFor: 'exporting' stamp: 'ToonVerwaest 7/19/2011 13:14'!
pExportedName
	^ (parent relativeNameFor: self name) asSymbol! !

!P4Package methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:58'!
parent
	^ parent! !

!P4Package methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:58'!
parent: anObject
	parent := anObject! !

!P4Package methodsFor: 'iterating' stamp: 'OliFlueckiger 7/15/2011 13:41'!
printOn: aStream 
	self printOn: aStream separatedBy: '.'  ! !

!P4Package methodsFor: 'filesystem' stamp: 'ToonVerwaest 5/16/2011 18:40'!
printOn: aStream separatedBy: separator
	parent isRootPackage ifFalse: [
		parent printOn: aStream separatedBy: separator.
		aStream << separator ].
	aStream << name! !

!P4Package methodsFor: 'filesystem' stamp: 'ToonVerwaest 7/19/2011 14:56'!
relativeNameFor: aName
	^ self relativeNameFor: aName separatedBy: '_'! !

!P4Package methodsFor: 'filesystem' stamp: 'CamilloBruni 4/13/2012 14:21'!
relativeNameFor: aName separatedBy: separator
	<preventExport>
	
	^ String new: 32 streamContents: [ :aStream|
		self printOn: aStream separatedBy: separator.
		aStream << separator << aName.]! !

!P4Package methodsFor: 'filesystem' stamp: 'ToonVerwaest 5/17/2011 14:49'!
relativePathNameFor: aName
	^ self relativeNameFor: aName separatedBy: '/'! !

P4AbstractPackage subclass: #P4RootPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Package'!

P4RootPackage class
	instanceVariableNames: 'instance'!

P4RootPackage class
	instanceVariableNames: 'instance'!

!P4RootPackage class methodsFor: 'instance creation' stamp: 'ToonVerwaest 5/16/2011 22:52'!
ensurePath: aPath
	| current |
	current := self instance.
	[ aPath isEmpty ] whileFalse: [ 
		current := current ensurePackage: aPath removeFirst ].
	^ current ! !

!P4RootPackage class methodsFor: 'pharo class loading' stamp: 'CamilloBruni 3/29/2012 13:44'!
flushPackages
	instance ifNil: [ ^ self ]. 
	instance classesDo: #flush.
	instance := nil.! !

!P4RootPackage class methodsFor: 'instance creation' stamp: 'OliFlueckiger 7/11/2011 15:29'!
instance
	^ instance ifNil: [ instance := self new ]! !

!P4RootPackage class methodsFor: 'instance creation' stamp: 'ToonVerwaest 5/24/2011 18:38'!
resolve: aPath
	| current |
	current := self instance.
	[ aPath isEmpty ] whileFalse: [ 
		current := current packageAt: aPath removeFirst ].
	^ current cls! !

!P4RootPackage methodsFor: 'filesystem' stamp: 'ToonVerwaest 7/18/2011 21:53'!
ensureDirectory
	<preventExport>
	^ FileDirectory default! !

!P4RootPackage methodsFor: 'testing' stamp: 'ToonVerwaest 5/16/2011 18:40'!
isRootPackage
	^ true! !

!P4RootPackage methodsFor: 'filesystem' stamp: 'ToonVerwaest 5/16/2011 18:37'!
printOn: aStream separatedBy: separator! !

!P4RootPackage methodsFor: 'filesystem' stamp: 'ToonVerwaest 5/16/2011 18:42'!
relativeNameFor: aName
	^ aName  ! !

P4Object variableSubclass: #P4Array
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

P4Array variableSubclass: #P4AbstractBucket
	instanceVariableNames: 'bucketSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4AbstractBucket class methodsFor: 'instance creation' stamp: 'ToonVerwaest 8/4/2010 11:40'!
new
	self shouldNotCall! !

!P4AbstractBucket class methodsFor: 'instance creation' stamp: 'OliFlueckiger 7/28/2011 14:33'!
new: sizeRequested
	^ (super basicNew: sizeRequested) initialize! !

!P4AbstractBucket methodsFor: 'accessing' stamp: 'ToonVerwaest 8/4/2010 11:36'!
bucketSize
	^ bucketSize! !

!P4AbstractBucket methodsFor: 'adding' stamp: 'ToonVerwaest 8/4/2010 11:36'!
copyFrom: aBucket
	1 to: aBucket bucketSize do: [ :idx | self at: idx put: (aBucket at: idx) ].
	bucketSize := aBucket bucketSize! !

!P4AbstractBucket methodsFor: 'initialization' stamp: 'ToonVerwaest 8/4/2010 11:37'!
initialize
	bucketSize := 0! !

!P4AbstractBucket methodsFor: 'testing' stamp: 'OliFlueckiger 8/5/2011 18:50'!
isFull
	^ bucketSize = self size! !

!P4AbstractBucket methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/15/2011 13:53'!
printOn: aStream
	aStream << 'a ' << self class name << ' {'.
	aStream cr.
	1 to: self bucketSize do: [ :i |
		(self pVariableAt: i) printOn: aStream.
		aStream << '. '  ].
	aStream << '}'.! !

!P4AbstractBucket methodsFor: 'removing' stamp: 'ToonVerwaest 8/5/2010 15:59'!
removeAll
	|oldSize|
	oldSize := bucketSize.
	bucketSize := 0.
	1 to: oldSize do: [:index | self at: index put: nil]! !

P4AbstractBucket variableSubclass: #P4DictBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4DictBucket class methodsFor: 'instance creation' stamp: 'OliFlueckiger 7/28/2011 15:45'!
new: sizeRequested
	^ super new: sizeRequested * 2! !

!P4DictBucket class methodsFor: 'instance creation' stamp: 'OliFlueckiger 7/22/2011 17:19'!
typeHints 
	<preventExport>
	^ {
		#self-> #'Kernel.Collection.DictBucket'
	} asDictionary! !

!P4DictBucket methodsFor: 'accessing' stamp: 'ToonVerwaest 8/4/2010 09:17'!
assign: key to: value
	1 to: bucketSize by: 2 do: [ :index |
		(self at: index) = key
			ifTrue: [ self at: index + 1 put: value. ^ true ]].
	^ false! !

!P4DictBucket methodsFor: 'accessing' stamp: 'ToonVerwaest 8/4/2010 09:36'!
at: aKey ifAbsent: aBlock
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) = aKey ifTrue: [ ^ self at: index + 1 ]].
	^ aBlock value! !

!P4DictBucket methodsFor: 'enumeration' stamp: 'ToonVerwaest 8/4/2010 10:16'!
do: aBlock
	2 to: bucketSize by: 2 do: [ :index | aBlock value: (self at: index) ]! !

!P4DictBucket methodsFor: 'testing' stamp: 'ToonVerwaest 8/4/2010 09:36'!
includes: anObject
	2 to: bucketSize by: 2 do: [ :index | 
		(self at: index) = anObject ifTrue: [ ^ true ]].
	^ false! !

!P4DictBucket methodsFor: 'testing' stamp: 'ToonVerwaest 8/5/2010 12:28'!
includesKey: aKey
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) = aKey ifTrue: [ ^ true ]].
	^ false! !

!P4DictBucket methodsFor: 'enumeration' stamp: 'ToonVerwaest 8/4/2010 09:53'!
keysAndValuesDo: aBlock
	1 to: bucketSize by: 2 do: [ :index | 
			"value: key v value: value value: index"
		aBlock value: (self at: index) value: (self at: index + 1) ]! !

!P4DictBucket methodsFor: 'enumeration' stamp: 'ToonVerwaest 8/4/2010 09:20'!
keysDo: aBlock
	1 to: bucketSize by: 2 do: [ :index | aBlock value: (self at: index) ]! !

!P4DictBucket methodsFor: 'adding' stamp: 'ToonVerwaest 8/3/2010 21:42'!
newKey: aKey value: anObject
	self at: bucketSize + 1 put: aKey.
	self at: bucketSize + 2 put: anObject.
	bucketSize := bucketSize + 2! !

!P4DictBucket methodsFor: 'removing' stamp: 'ToonVerwaest 8/4/2010 09:25'!
remove: aKey ifAbsent: aBlock
	| value |
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) = aKey
			ifTrue: [
				value := self at: index + 1.
				self removeAt: index.
				^ value ]].
	^ aBlock value! !

!P4DictBucket methodsFor: 'removing' stamp: 'ToonVerwaest 8/4/2010 09:19'!
removeAt: index
	self at: index put: (self at: bucketSize - 1).
	self at: index + 1 put: (self at: bucketSize).
	bucketSize := bucketSize - 2.
	self at: bucketSize + 1 put: nil.
	self at: bucketSize + 2 put: nil! !

!P4DictBucket methodsFor: 'accessing' stamp: 'ToonVerwaest 8/5/2010 11:33'!
scanFor: aKey
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) = aKey ifTrue: [ ^ index ]].
	^ 0! !

P4DictBucket variableSubclass: #P4IdentityDictBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4IdentityDictBucket class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/22/2011 17:19'!
typeHints 
	<preventExport>
	^ super typeHints addAll:
	{
		#self-> #'Kernel.Collection.IdentityDictBucket'
	} asDictionary! !

!P4IdentityDictBucket methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 20:48'!
assign: key to: value
	1 to: bucketSize by: 2 do: [ :index |
		(self at: index) == key
			ifTrue: [ self at: index + 1 put: value. ^true ]].
	^ false! !

!P4IdentityDictBucket methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 20:29'!
at: aKey ifAbsent: aBlock
	<groundTypes>
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) == aKey ifTrue: [ ^ self at: 1 + index ]].
	^ aBlock value! !

!P4IdentityDictBucket methodsFor: 'testing' stamp: 'ToonVerwaest 8/5/2010 12:28'!
includesKey: aKey
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) == aKey ifTrue: [ ^ true ]].
	^ false! !

!P4IdentityDictBucket methodsFor: 'removing' stamp: 'ToonVerwaest 8/4/2010 11:42'!
remove: aKey ifAbsent: aBlock
	| value |
	1 to: bucketSize by: 2 do: [ :index | 
		(self at: index) == aKey
			ifTrue: [
				value := self at: index + 1.
				self removeAt: index.
				^ value ]].
	^ aBlock value! !

P4AbstractBucket variableSubclass: #P4SetBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

P4SetBucket variableSubclass: #P4IdentitySetBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4IdentitySetBucket methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 8/5/2010 15:33'!
includes: anObject
	1 to: bucketSize do: [ :index | 
			(self at: index) == anObject ifTrue: [ ^ true ] ].
	^ false! !

!P4IdentitySetBucket methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 8/5/2010 15:34'!
remove: anObject ifAbsent: aBlock
	1 to: bucketSize do: [ :index |
		(self at: index) == anObject
			ifTrue: [ self removeAt: index. ^ anObject ]].
	^ aBlock value! !

!P4SetBucket methodsFor: 'adding' stamp: 'ToonVerwaest 8/4/2010 11:16'!
addNew: value
	^ self at: (bucketSize := bucketSize + 1) put: value! !

!P4SetBucket methodsFor: 'enumeration' stamp: 'ToonVerwaest 8/4/2010 11:02'!
do: aBlock
	1 to: bucketSize do: [ :index | aBlock value: (self at: index) ]! !

!P4SetBucket methodsFor: 'testing' stamp: 'CamilloBruni 7/27/2010 22:30'!
includes: anObject
	1 to: bucketSize do: [ :index | 
			(self at: index) = anObject ifTrue: [ ^ true ] ].
	^ false! !

!P4SetBucket methodsFor: 'removing' stamp: 'ToonVerwaest 8/4/2010 11:09'!
remove: anObject ifAbsent: aBlock
	1 to: bucketSize do: [ :index |
		(self at: index) = anObject
			ifTrue: [ self removeAt: index. ^ anObject ]].
	^ aBlock value! !

!P4SetBucket methodsFor: 'removing' stamp: 'ToonVerwaest 8/5/2010 15:34'!
removeAt: anInteger
	self at: anInteger put: (self at: bucketSize).
	bucketSize := bucketSize - 1.
	self at: bucketSize + 1 put: nil. ! !

!P4Array class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/11/2011 12:57'!
isIndexed 
	^true! !

!P4Array class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/28/2011 17:27'!
with: stuff
	| array |
	array := self basicNew: 1.
	array basicAt: 1 put: stuff.
	^array! !

!P4Array methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/8/2011 14:56'!
do: aBlock
	| size |
	size := self size.
	1 to: size do: [ :element |
		aBlock value: (self at: element) ]! !

!P4Array methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/13/2011 10:45'!
pInspect 
	'an Array' print.
	self do: [ :e | e printObj ]! !

!P4Array methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/15/2011 13:44'!
printOn: aStream
	aStream << '{'.
	1 to: self size do: [ :i |
		(self pVariableAt: i) printOn: aStream.
		aStream << '. '  ].
	aStream << '}'.! !

P4Array variableSubclass: #P4RemoteArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4RemoteArray class methodsFor: 'instance creation' stamp: 'OliFlueckiger 7/26/2011 19:09'!
pNew: size
	<globalName: #remoteArrayNew>
	<preventExport>! !

P4Object subclass: #P4Behavior
	instanceVariableNames: 'instanceHeader behavior layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Behavior'!

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 16:46'!
basicNew
	<pprimitive: #basicNew>
	self pHalt.! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 16:54'!
basicNew: n
	<pprimitive: #'basicNew_'>
	self pHalt.! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:40'!
initialize 
	<preventExport>
	behavior := P4SmalltalkBehavior for: self! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 15:54'!
installMethod: aMethod  
	behavior installMethod: aMethod  ! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 13:12'!
instanceHeader
	^ instanceHeader! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 13:12'!
instanceHeader: anObject
	instanceHeader := anObject! !

!P4Behavior methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 14:34'!
layout
	^ layout! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 15:54'!
methodDictionary
	^ behavior methodDictionary! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 15:54'!
methodDictionary: aMethodDictionary
	behavior methodDictionary: aMethodDictionary! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 7/28/2011 18:32'!
new
	^ self basicNew initialize! !

!P4Behavior methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/28/2011 18:32'!
new: n
	^ (self basicNew: n) initialize! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 22:54'!
setBehavior: anObject
	behavior := anObject! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:03'!
superclass
	^ behavior superclass! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:03'!
superclass: aSuperclass 
	behavior superclass: aSuperclass ! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:32'!
theBehavior
	^ behavior! !

!P4Behavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:32'!
theClass
	^ self! !

P4Behavior subclass: #P4Class
	instanceVariableNames: 'name package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Behavior'!

!P4Class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/18/2011 21:24'!
dumpGlobalOn: bo
	self error: 'Should go via pharo class'! !

!P4Class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/18/2011 21:24'!
dumpLocalOn: bo
	self error: 'Should go via pharo class'! !

!P4Class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 15:57'!
name
	^ name
! !

!P4Class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 15:57'!
name: anObject
	name := anObject! !

!P4Class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/21/2011 16:20'!
pExportedName
	^ (self package relativeNameFor: self name) asSymbol! !

!P4Class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 15:57'!
package
	^ package! !

!P4Class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 15:57'!
package: anObject
	package := anObject! !

!P4Class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/15/2011 13:39'!
printOn: aStream
	aStream << name.! !

P4Behavior subclass: #P4Metaclass
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Behavior'!

!P4Metaclass class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/25/2011 12:44'!
pExportedName
	^ self == P4Metaclass
		ifTrue: [ #Metaclass ]
		ifFalse: [ super pExportedName ]! !

!P4Metaclass methodsFor: 'accessing' stamp: 'OliFlueckiger 7/20/2011 16:22'!
instance: aClass
	instance := aClass! !

!P4Metaclass methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 11:46'!
pExportedName 
	^ (instance pExportedName,'_class') asSymbol ! !

P4Object subclass: #P4Boolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Boolean'!

P4Boolean subclass: #P4False
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Boolean'!

!P4False methodsFor: 'spec' stamp: 'abc 2/6/2012 15:34'!
and: aClosure
	^ false! !

!P4False methodsFor: 'spec' stamp: 'OliFlueckiger 8/24/2011 16:56'!
ifFalse: aBlock
	^ aBlock value  ! !

!P4False methodsFor: 'spec' stamp: 'OliFlueckiger 8/29/2011 13:05'!
ifFalse: aFalseBlock ifTrue: aBlock
	^aFalseBlock value! !

!P4False methodsFor: 'spec' stamp: 'OliFlueckiger 8/24/2011 16:56'!
ifTrue: aBlock  ! !

!P4False methodsFor: 'spec' stamp: 'OliFlueckiger 8/29/2011 13:05'!
ifTrue: aBlock  ifFalse: aFalseBlock
	^aFalseBlock value! !

!P4False methodsFor: 'spec' stamp: 'OliFlueckiger 10/4/2011 16:19'!
not
	^ true! !

!P4False methodsFor: 'spec' stamp: 'OliFlueckiger 10/4/2011 16:18'!
xor: aBoolean
	^aBoolean value! !

P4Boolean subclass: #P4True
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Boolean'!

!P4True methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 10/4/2011 16:19'!
not
	^ false! !

!P4True methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/29/2011 06:28'!
shouldBeTrue
! !

!P4True methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 10/4/2011 16:18'!
xor: aBoolean
	^aBoolean value not! !

P4Object subclass: #P4Callable
	instanceVariableNames: 'code arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Callable'!

P4Callable variableSubclass: #P4Closure
	instanceVariableNames: 'outerScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Callable'!

!P4Closure class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 19:10'!
pNew: size
	<globalName:#closureNew>
	<preventExport>
	"not really a primitive since the receiver is not passed, only the untagged size..."! !

!P4Closure methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/1/2011 11:06'!
return
	<globalName: #closureReturn>
	<preventExport>! !

P4Callable variableSubclass: #P4Method
	instanceVariableNames: 'selector host package usedGlobals usedReferences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Callable'!

!P4Method class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/5/2012 11:46'!
fromTac: aMethod
	| literals result |
	literals := aMethod literals.
	
	result := self new: literals size.
	
	1 to: literals size do: [:i | 
		result at: i put: (literals at: i)].
	
	result code: aMethod codeStream contents.
	result host: aMethod host.
	result selector: aMethod selector.
	^ result
	! !

!P4Method class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/14/2011 18:14'!
pInstSize 
	^ self instSize - 2! !

!P4Method class methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 7/25/2011 21:24'!
pIsBytes
	^ true! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
code
	^ code! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
code: anObject
	code := anObject! !

!P4Method methodsFor: 'exporting' stamp: 'ToonVerwaest 7/19/2011 13:38'!
dumpOn: binaryOut
	<preventExport>
	| myRef |
	myRef := super dumpOn: binaryOut.  
	binaryOut resolveReferences: self reference: myRef.
	^ myRef! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
host
	^ host! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
host: anObject
	host := anObject! !

!P4Method methodsFor: 'accessing' stamp: 'OliFlueckiger 9/7/2011 13:39'!
numArgs
	selector countArgs  ! !

!P4Method methodsFor: 'exporting' stamp: 'OliFlueckiger 7/14/2011 16:13'!
pByteAt: i
	^ code at: i.
	! !

!P4Method methodsFor: 'exporting' stamp: 'OliFlueckiger 7/14/2011 16:49'!
pByteName
	^ host earlySelectorAddress: selector  ! !

!P4Method methodsFor: 'exporting' stamp: 'OliFlueckiger 7/14/2011 16:07'!
pByteSize
	^ code size! !

!P4Method methodsFor: 'exporting' stamp: 'OliFlueckiger 8/9/2011 16:01'!
pInstVarAt: i
	<preventExport>
	i = 1 ifTrue: [ ^ self pVariableSize + self class pInstSize  ].
	^ super pInstVarAt: i! !

!P4Method methodsFor: 'exporting' stamp: 'OliFlueckiger 7/15/2011 15:22'!
pVariableSize
	^ self basicSize! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
package
	^ package! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
package: anObject
	package := anObject! !

!P4Method methodsFor: 'accessing' stamp: 'OliFlueckiger 7/15/2011 13:42'!
printOn: aStream
	aStream << '>>' << selector! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
selector
	^ selector! !

!P4Method methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 17:02'!
selector: anObject
	selector := anObject! !

!P4Method methodsFor: 'accessing' stamp: 'OliFlueckiger 7/8/2011 10:51'!
usedGlobals
	^ usedGlobals! !

!P4Method methodsFor: 'accessing' stamp: 'OliFlueckiger 7/8/2011 10:51'!
usedGlobals: anObject
	usedGlobals := anObject! !

!P4Method methodsFor: 'accessing' stamp: 'OliFlueckiger 7/8/2011 10:51'!
usedReferences
	^ usedReferences! !

!P4Method methodsFor: 'accessing' stamp: 'OliFlueckiger 7/8/2011 10:51'!
usedReferences: anObject
	usedReferences := anObject! !

P4Object subclass: #P4Character
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-String'!

P4Object subclass: #P4ClassReference
	instanceVariableNames: 'cls package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Package'!

!P4ClassReference methodsFor: 'iterating' stamp: 'ToonVerwaest 5/24/2011 17:50'!
classesDo: action
	action value: cls! !

!P4ClassReference methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 16:27'!
cls
	^ cls! !

!P4ClassReference methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 16:27'!
cls: anObject
	cls := anObject! !

!P4ClassReference methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 16:27'!
package
	^ package! !

!P4ClassReference methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 16:54'!
package: anObject
	package := anObject.
	cls ifNotNil: [ cls package: anObject ]  ! !

!P4ClassReference methodsFor: 'iterating' stamp: 'ToonVerwaest 7/19/2011 13:46'!
packagesDo: action
! !

P4Object subclass: #P4Console
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-IO'!

!P4Console class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 16:51'!
print: msg
	<pprimitive: #print>
	self pHalt.! !

P4Object variableSubclass: #P4DoesNotUnderstand
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Callable'!

!P4DoesNotUnderstand methodsFor: 'accessing' stamp: 'OliFlueckiger 9/7/2011 16:44'!
arguments
	^ arguments! !

!P4DoesNotUnderstand methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/8/2011 16:08'!
perform: aSelector on: receiver with: args
	<groundTypes>
	<typeHint: #receiver as: #'Kernel.Object.Object'>
	arguments := args.
	selector := aSelector.
	^ receiver doesNotUnderstand: self  ! !

!P4DoesNotUnderstand methodsFor: 'accessing' stamp: 'OliFlueckiger 9/7/2011 16:44'!
selector
	^ selector! !

P4Object subclass: #P4Exception
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Exception'!

!P4Exception methodsFor: 'PharoIntegration' stamp: 'OliFlueckiger 5/5/2011 17:54'!
defaultAction
	"No one has handled this error, but now give them a chance to decide
	how to debug it. If none handle this either then open debugger (see
	UnhandedError-defaultAction) "
	<preventExport>
	UnhandledError signalForException: self! !

!P4Exception methodsFor: 'PharoIntegration' stamp: 'ToonVerwaest 7/19/2011 17:31'!
description
	<preventExport>
	"Return a textual description of the exception."
	| desc mt |
	desc := self class name asString.
	^ (mt := self messageText) == nil
		ifTrue: [desc]
		ifFalse: [desc , ': ' , mt]! !

!P4Exception methodsFor: 'PharoIntegration' stamp: 'ToonVerwaest 7/19/2011 17:32'!
messageText
	<preventExport>
	| stream |
	stream := WriteStream on: ''.
	self warnOn: stream.
	^ stream contents! !

!P4Exception methodsFor: 'PharoIntegration' stamp: 'OliFlueckiger 8/9/2011 13:38'!
pSignal
	<renameExport: #signal>
	'---> signalled:' print.
	self printObj.
	self pHalt.
	
	! !

!P4Exception methodsFor: 'PharoIntegration' stamp: 'OliFlueckiger 5/5/2011 17:52'!
signal
	"Ask ContextHandlers in the sender chain to handle this signal. The
	default is to execute and return my defaultAction."
	<preventExport>
	environment := thisContext contextTag.
	^ environment nextHandlerContext handleSignal: self! !

!P4Exception methodsFor: 'PharoIntegration' stamp: 'OliFlueckiger 5/5/2011 17:54'!
signalerContext
	<preventExport>
	^ environment
		findContextSuchThat: [:ctxt | (ctxt receiver == self
				or: [ctxt receiver == self class]) not]! !

P4Exception subclass: #P4KeyNotFound
	instanceVariableNames: 'dictionary key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4KeyNotFound methodsFor: 'accessing' stamp: 'ToonVerwaest 8/20/2010 11:58'!
dictionary
	^ dictionary! !

!P4KeyNotFound methodsFor: 'accessing' stamp: 'ToonVerwaest 8/20/2010 11:58'!
dictionary: anObject
	dictionary := anObject! !

!P4KeyNotFound methodsFor: 'accessing' stamp: 'ToonVerwaest 8/20/2010 11:58'!
key
	^ key! !

!P4KeyNotFound methodsFor: 'accessing' stamp: 'ToonVerwaest 8/20/2010 11:58'!
key: anObject
	key := anObject! !

!P4KeyNotFound methodsFor: 'printing' stamp: 'ToonVerwaest 8/20/2010 12:00'!
warnOn: aStream
	aStream << 'Key not found: '.
	key printOn: aStream.! !

P4Object subclass: #P4Float
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Number'!

P4Object subclass: #P4HashedCollection
	instanceVariableNames: 'size maxLinear ratio buckets linear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

P4HashedCollection subclass: #P4Dictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4Dictionary class methodsFor: 'staticTyping' stamp: 'ToonVerwaest 7/23/2011 19:12'!
pExportedName 
	^ self == P4Dictionary
		ifTrue: [ #Dictionary ]
		ifFalse: [ super pExportedName ]! !

!P4Dictionary class methodsFor: 'staticTyping' stamp: 'OliFlueckiger 7/22/2011 16:15'!
typeHints
	<preventExport>
	^ super typeHints addAll: {
		#self -> #'Kernel.Collection.Dictionary'
	} asDictionary ! !

!P4Dictionary methodsFor: 'adding' stamp: 'ToonVerwaest 8/4/2010 09:54'!
addAll: aDictionary
	aDictionary == self ifTrue: [ ^ self ].
	aDictionary keysAndValuesDo: [:key :value | self at: key put: value].
	^ aDictionary.! !

!P4Dictionary methodsFor: 'accessing' stamp: 'ToonVerwaest 8/20/2010 12:08'!
at: key
	^ self at: key ifAbsent: [ self errorKeyNotFound: key ]! !

!P4Dictionary methodsFor: 'accessing' stamp: 'ToonVerwaest 7/23/2011 18:40'!
at: key ifAbsent: aBlock
	<pPrimitive: #at:ifAbsent: plugin: #'Collection.Dictionary'>
	linear ifTrue: [ ^ (buckets at: 1) at: key ifAbsent: aBlock ].
	^ (buckets at: key pHash \\ buckets size + 1)
		ifNil: [ aBlock value ]
		ifNotNil: [ :bucket | bucket at: key ifAbsent: aBlock ]! !

!P4Dictionary methodsFor: 'accessing' stamp: 'ToonVerwaest 3/25/2010 12:39'!
at: key ifAbsentPut: aBlock
	^ self at: key ifAbsent: [ self at: key put: aBlock value ]! !

!P4Dictionary methodsFor: 'accessing' stamp: 'ToonVerwaest 8/4/2010 09:58'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver.
	If it is present, answer the value of evaluating the given block with the value associated with the key.
	Otherwise, answer nil."
	^ aBlock value: (self at: key ifAbsent: [ ^ nil ])! !

!P4Dictionary methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 14:56'!
at: key put: anObject
	| bucketIndex bucket |
	linear ifTrue: [ ^ self inFirstBucketAt: key put: anObject ].
		
	bucketIndex := key pHash \\ buckets size + 1.
	bucket := buckets at: bucketIndex.
	bucket ifNil: [
		(self newBucketAt: bucketIndex) newKey: key value: anObject.
		self checkGrow.
		^ anObject ].
	(bucket assign: key to: anObject) ifTrue: [ ^ anObject ].
	bucket isFull ifTrue: [ bucket := self growBucketAt: bucketIndex ].
	bucket newKey: key value: anObject.
	self checkGrow.
	^ anObject! !

!P4Dictionary methodsFor: 'inspecting' stamp: 'ToonVerwaest 8/9/2010 15:14'!
collect: aBlock displayingProgress: aString
	<preventExport>
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := Dictionary new.
	(self keysAndValuesDo:[:key :value |
		newCollection at: key put: (aBlock value: value).
	]).
	^newCollection! !

!P4Dictionary methodsFor: 'error handling' stamp: 'ToonVerwaest 7/19/2011 16:34'!
errorKeyNotFound: aKey
	^ P4KeyNotFound new
		key: aKey;
		dictionary: self;
		signal! !

!P4Dictionary methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 16:46'!
inFirstBucketAt: key ifAbsentPut: aBlock
	^ (buckets at: 1) at: key ifAbsent: [
		^ self inFirstBucketAtNew: key put: aBlock value ]! !

!P4Dictionary methodsFor: 'private' stamp: 'OliFlueckiger 8/24/2011 13:24'!
inFirstBucketAt: key put: anObject
	^ ((buckets at: 1) assign: key to: anObject)
		ifTrue: [ anObject ]
		ifFalse: [ self inFirstBucketAtNew: key put: anObject ]! !

!P4Dictionary methodsFor: 'private' stamp: 'OliFlueckiger 8/29/2011 19:03'!
inFirstBucketAtNew: key put: value
	| bucket |
	bucket := buckets at: 1.
	bucket isFull ifTrue: [
		(bucket size < maxLinear)
			ifFalse: [
				linear := false.
				buckets := Array new: 32.
				self reAddBucket: bucket at: 1.
				^ self at: key put: value ].
		bucket := self growBucketAt: 1 ].
	bucket newKey: key value: value.
	size := size + 1.
	^ value! !

!P4Dictionary methodsFor: 'testing' stamp: 'ToonVerwaest 8/5/2010 12:16'!
includes: anObject
	self bucketsDo: [ :bucket | (bucket includes: anObject) ifTrue: [ ^ true ]].
	^ false! !

!P4Dictionary methodsFor: 'testing' stamp: 'ToonVerwaest 7/23/2011 18:40'!
includesKey: key
	<pPrimitive: #includesKey: plugin: #'Collection.Dictionary'>
	linear ifTrue: [ ^ (buckets at: 1) includesKey: key ].
	^ (buckets at: key pHash \\ buckets size + 1)
		ifNil: [ false ]
		ifNotNil: [ :bucket | bucket includesKey: key ]! !

!P4Dictionary methodsFor: 'inspecting' stamp: 'ToonVerwaest 8/31/2010 14:36'!
inspectChildrenOn: inspector
	self keysAndValuesDo: [ :key :value |
		inspector child: key value: [ value ]]! !

!P4Dictionary methodsFor: 'accessing' stamp: 'ToonVerwaest 7/19/2011 16:33'!
keys
	| keys index |
	keys := Array new: size.
	index := 0.
	self keysDo: [ :key | keys at: (index := index + 1) put: key ].
	^ keys! !

!P4Dictionary methodsFor: 'enumerating' stamp: 'ToonVerwaest 8/4/2010 09:53'!
keysAndValuesDo: aBlock
	self bucketsDo: [ :bucket | bucket keysAndValuesDo: aBlock ]
	! !

!P4Dictionary methodsFor: 'enumerating' stamp: 'ToonVerwaest 8/4/2010 11:48'!
keysDo: aBlock
	self bucketsDo: [ :bucket | bucket keysDo: aBlock ]
	! !

!P4Dictionary methodsFor: 'private' stamp: 'ToonVerwaest 7/19/2011 16:33'!
newBucket: sizeRequested
	^ P4DictBucket new: sizeRequested! !

!P4Dictionary methodsFor: 'adding' stamp: 'OliFlueckiger 7/21/2011 13:08'!
printOn: stream
	stream << 'a Dictionary {'.
	stream cr.
	self keysAndValuesDo: [ :k :v |
		k printOn: stream.
		stream << ' -> '.
		v printOn: stream.
		stream cr ] .
	stream << '}'! !

!P4Dictionary methodsFor: 'private' stamp: 'ToonVerwaest 7/23/2011 18:40'!
reAddBucket: bucket at: index
	| c key bucketIndex |
	c := 1.
	buckets at: index put: bucket.
	[ c <= bucket bucketSize ] whileTrue: [ 
			key := bucket at: c.
			bucketIndex := key pHash \\ buckets size + 1.
			bucketIndex = index
				ifTrue: [ c := c + 2 ]
				ifFalse: [ 
					(self bucketWithRoomAt: bucketIndex) newKey: key value: (bucket at: c + 1).
					bucket removeAt: c ] ]! !

!P4Dictionary methodsFor: 'removing' stamp: 'ToonVerwaest 3/25/2010 12:39'!
remove: anObject ifAbsent: aBlock
	self shouldNotCall! !

!P4Dictionary methodsFor: 'removing' stamp: 'OliFlueckiger 7/21/2011 11:55'!
removeKey: key
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."

	^ self removeKey: key ifAbsent: [ self errorKeyNotFound: key ]! !

!P4Dictionary methodsFor: 'removing' stamp: 'ToonVerwaest 7/23/2011 18:41'!
removeKey: key ifAbsent: aBlock
	| value bucket |
	linear ifTrue: [
		value := (buckets at: 1) remove: key ifAbsent: [ ^ aBlock value ].
		self checkShrink.
		^ value ].
	bucket := buckets at: key pHash \\ buckets size + 1.
	bucket ifNil: [ ^ aBlock value ].
	value := bucket remove: key ifAbsent: [ ^ aBlock value ].
	self checkShrink.
	^ value! !

!P4Dictionary methodsFor: 'selecting' stamp: 'ToonVerwaest 8/3/2010 13:51'!
select: aBlock 
	"Evaluate aBlock with each of my values as the argument. Collect into a new dictionary, only those associations for which aBlock evaluates to true."

	| newCollection |
	newCollection := self copyEmpty.
	self keysAndValuesDo: [ :key :value |
		(aBlock value: value) ifTrue: [
			newCollection at: key put: value ] ].
	^newCollection! !

!P4Dictionary methodsFor: 'accessing' stamp: 'ToonVerwaest 7/19/2011 16:33'!
values
	| values index |
	values := Array new: size.
	index := 0.
	self do: [ :value | values at: (index := index + 1) put: value ].
	^ values! !

!P4Dictionary methodsFor: 'enumerating' stamp: 'ToonVerwaest 8/4/2010 10:17'!
valuesDo: aBlock
	self bucketsDo: [ :bucket | bucket do: aBlock ]
	! !

P4Dictionary subclass: #P4IdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4IdentityDictionary class methodsFor: 'statictyping' stamp: 'ToonVerwaest 7/23/2011 19:12'!
pExportedName 
	^ self == P4IdentityDictionary
		ifTrue: [ #IdentityDictionary ]
		ifFalse: [ super pExportedName ]! !

!P4IdentityDictionary class methodsFor: 'statictyping' stamp: 'OliFlueckiger 7/22/2011 16:15'!
typeHints 
	<preventExport>
	^ super typeHints addAll:
	{
		#buckets -> #'Kernel.Collection.Array'.
		#self-> #'Kernel.Collection.IdentityDictionary'
	} asDictionary! !

!P4IdentityDictionary methodsFor: 'private' stamp: 'OliFlueckiger 8/29/2011 20:29'!
at: key ifAbsent: aBlock
	<typeHint: #bucket as: #'Kernel.Collection.IdentityDictBucket'>
	<typeHint: #hash as: #'Kernel.Number.SmallInteger'>
	<fixedType: #key as: #'Kernel.Object.Object'>
	<groundTypes>
	| bucket hash |
	linear ifTrue: [ bucket := (buckets at: 1). ^ bucket at: key ifAbsent: aBlock ].
	hash := key identityHash.
	bucket := buckets at: 1 + (hash \\ buckets size).
	^ bucket
		ifNil: [ aBlock value ]
		ifNotNil: [bucket at: key ifAbsent: aBlock ]! !

!P4IdentityDictionary methodsFor: 'private' stamp: 'OliFlueckiger 8/5/2011 14:39'!
at: key put: anObject
	| bucketIndex bucket |
	
	linear ifTrue: [ ^ self inFirstBucketAt: key put: anObject ].
		
	bucketIndex := key identityHash \\ buckets size + 1.
	bucket := buckets at: bucketIndex.
	bucket ifNil: [
		(self newBucketAt: bucketIndex) newKey: key value: anObject.
		self checkGrow.
		^ anObject ].
	(bucket assign: key to: anObject) ifTrue: [ ^ anObject ].
	bucket isFull ifTrue: [ bucket := self growBucketAt: bucketIndex ].
	bucket newKey: key value: anObject.
	self checkGrow.
	^ anObject! !

!P4IdentityDictionary methodsFor: 'private' stamp: 'ToonVerwaest 7/23/2011 18:39'!
includesKey: key
	linear ifTrue: [ ^ (buckets at: 1) includesKey: key ].
	^ (buckets at: key identityHash \\ buckets size + 1)
		ifNil: [ false ]
		ifNotNil: [ :bucket | bucket includesKey: key ]! !

!P4IdentityDictionary methodsFor: 'private' stamp: 'ToonVerwaest 7/23/2011 18:33'!
newBucket: sizeRequested
	^ P4IdentityDictBucket new: sizeRequested! !

!P4IdentityDictionary methodsFor: 'private' stamp: 'OliFlueckiger 9/6/2011 14:04'!
reAddBucket: bucket at: index
	| c key bucketIndex |
	c := 1.
	buckets at: index put: bucket.
	[ c <= bucket bucketSize ] whileTrue: [ 
			key := bucket at: c.
			bucketIndex := key identityHash \\ buckets size + 1.
			bucketIndex = index
				ifTrue: [ c := c + 2 ]
				ifFalse: [ 
					(self bucketWithRoomAt: bucketIndex) newKey: key value: (bucket at: c + 1).
					bucket removeAt: c ] ]! !

!P4IdentityDictionary methodsFor: 'removing' stamp: 'ToonVerwaest 7/23/2011 18:39'!
removeKey: key ifAbsent: aBlock
	| value bucket |
	linear ifTrue: [
		value := (buckets at: 1) remove: key ifAbsent: [ ^ aBlock value ].
		self checkShrink.
		^ value ].
	bucket := buckets at: key identityHash \\ buckets size + 1.
	bucket ifNil: [ ^ aBlock value ].
	value := bucket remove: key ifAbsent: [ ^ aBlock value ].
	self checkShrink.
	^ value! !

P4IdentityDictionary subclass: #P4MethodDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Behavior'!

!P4MethodDictionary class methodsFor: 'statictyping' stamp: 'ToonVerwaest 7/23/2011 19:12'!
pExportedName 
	^ self == P4MethodDictionary
		ifTrue: [ #MethodDictionary ]
		ifFalse: [ super pExportedName ]! !

!P4MethodDictionary class methodsFor: 'statictyping' stamp: 'OliFlueckiger 8/9/2011 18:57'!
typeHints 
	<preventExport>
	^ super typeHints addAll:
	{
		#self-> #'Kernel.Behavior.MethodDictionary'
	} asDictionary! !

!P4MethodDictionary methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 16:26'!
at: key
	<groundTypes>
	^ self at: key ifAbsent: nil! !

!P4HashedCollection class methodsFor: 'initialize-release' stamp: 'ToonVerwaest 8/5/2010 15:59'!
new: preferredSize
	^ super new initialize: preferredSize! !

!P4HashedCollection class methodsFor: 'initialize-release' stamp: 'ToonVerwaest 8/5/2010 15:59'!
newFrom: aCollection
	"Answer an instance of me containing the same elements as aCollection."
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection addAll: aCollection.
	^ newCollection! !

!P4HashedCollection class methodsFor: 'initialize-release' stamp: 'OliFlueckiger 7/22/2011 16:17'!
typeHints
	<preventExport>
	^ {
		#size -> #'Kernel.Number.SmallInteger'.
		#maxLinear -> #'Kernel.Number.SmallInteger'.
		#ratio -> #'Kernel.Number.SmallInteger'.
		#buckets -> #'Kernel.Collection.Array'.
		#linear -> #'Kernel.Boolean.Boolean'.
	} asDictionary ! !

!P4HashedCollection methodsFor: 'conversion' stamp: 'CamilloBruni 12/14/2011 16:27'!
asArray
	^ Array new: self size streamContents: [ :s|
		self do: [ :element|
			s nextPut: element ]].! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:48'!
bucketWithRoomAt: index
	^ (buckets at: index)
		ifNil: [ self newBucketAt: index ]
		ifNotNil: [ :bucket |
			bucket isFull ifTrue: [ ^ self growBucketAt: index ].
			bucket ]! !

!P4HashedCollection methodsFor: 'enumerating' stamp: 'ToonVerwaest 8/5/2010 15:49'!
bucketsDo: aBlock
	1 to: buckets size do: [ :index |
		(buckets at: index) ifNotNil: [ :bucket | aBlock value: bucket ] ]! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:49'!
checkGrow
	size := size + 1.
	(size * 100 // buckets size > ratio) ifTrue: [ self grow ]! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:49'!
checkShrink
	size := size - 1.
	" TODO test if should shrink. ifTrue: [ self shrink ]"! !

!P4HashedCollection methodsFor: 'copying' stamp: 'ToonVerwaest 8/5/2010 15:56'!
copyEmpty
	"Answer an empty copy of this collection"
	^self species new: self size! !

!P4HashedCollection methodsFor: 'enumerating' stamp: 'OliFlueckiger 12/7/2011 17:40'!
do: aBlock
	^ self bucketsDo: [ :bucket | bucket do: aBlock ]! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 7/19/2011 16:34'!
grow
	| oldBuckets |
	oldBuckets := buckets.
	buckets := Array new: oldBuckets size * 2.
	1 to: oldBuckets size do: [ :index |
		(oldBuckets at: index) ifNotNil: [ :bucket |
			self reAddBucket: bucket at: index]].! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:57'!
growBucketAt: index
	| oldBucket newBucket |
	oldBucket := buckets at: index.
	newBucket := self newBucket: oldBucket size * 2.
	newBucket copyFrom: oldBucket.
	buckets at: index put: newBucket.
	^ newBucket! !

!P4HashedCollection methodsFor: 'initialization' stamp: 'ToonVerwaest 8/5/2010 15:49'!
initialize
	self initialize: 20! !

!P4HashedCollection methodsFor: 'initialization' stamp: 'ToonVerwaest 7/19/2011 16:34'!
initialize: preferredSize
	size := 0.
	ratio := 500.
	maxLinear := 20.
	(linear := preferredSize <= maxLinear)
		ifTrue: [ buckets := Array with: (self newBucket: preferredSize) ]
		ifFalse: [ "TODO calculate proper size here"
			buckets := Array new: 32 ]! !

!P4HashedCollection methodsFor: 'private' stamp: 'OliFlueckiger 8/5/2011 17:55'!
isLinear
	^ linear! !

!P4HashedCollection methodsFor: 'accessing' stamp: 'ToonVerwaest 8/5/2010 15:56'!
maxLinear: anInteger
	maxLinear := anInteger! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:56'!
newBucketAt: bucketIndex
	^ buckets at: bucketIndex put: (self newBucket: 4)! !

!P4HashedCollection methodsFor: 'accessing' stamp: 'ToonVerwaest 8/5/2010 15:55'!
ratio: aFloat
	<preventExport>
	ratio := (aFloat * 100) ceiling! !

!P4HashedCollection methodsFor: 'removing' stamp: 'ToonVerwaest 8/5/2010 15:55'!
removeAll
	size := 0.
	self bucketsDo: [:bucket| bucket removeAll ].! !

!P4HashedCollection methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:55'!
shrink
	"TODO"

	! !

!P4HashedCollection methodsFor: 'accessing' stamp: 'ToonVerwaest 8/5/2010 15:56'!
size
	^ size! !

P4HashedCollection subclass: #P4Set
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

P4Set subclass: #P4IdentitySet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Collection'!

!P4IdentitySet class methodsFor: 'accessing' stamp: 'ToonVerwaest 5/20/2011 16:12'!
bucketClass
	^ P4IdentitySetBucket! !

!P4IdentitySet methodsFor: 'adding' stamp: 'ToonVerwaest 8/5/2010 15:52'!
add: value
	| bucketIndex bucket |
	linear ifTrue: [ ^ self addInFirstBucket: value ].
	
	bucketIndex := (value identityHash \\ buckets size) + 1.
	bucket := buckets at: bucketIndex.
	bucket ifNil: [
		bucket := self newBucketAt: bucketIndex.
		bucket addNew: value.
		self checkGrow.
		^ value ].
	(bucket includes: value) ifTrue: [ ^ value ].
	bucket isFull ifTrue: [ bucket := self growBucketAt: bucketIndex ].
	bucket addNew: value.
	self checkGrow.
	^ value! !

!P4IdentitySet methodsFor: 'testing' stamp: 'ToonVerwaest 8/5/2010 15:53'!
includes: anObject
	linear ifTrue: [ ^ (buckets at: 1) includes: anObject ].
	^ (buckets at: anObject identityHash \\ buckets size + 1)
		ifNil: [ false ]
		ifNotNil: [ :bucket | bucket includes: anObject ]! !

!P4IdentitySet methodsFor: 'private' stamp: 'ToonVerwaest 7/18/2011 22:38'!
newBucket: sizeRequested
	<preventExport>
	self flag: 'ne'.
	^ P4IdentitySetBucket new: sizeRequested! !

!P4IdentitySet methodsFor: 'private' stamp: 'ToonVerwaest 8/5/2010 15:54'!
reAddBucket: bucket at: index
	| c item bucketIndex |
	buckets at: index put: bucket.
	c := 1.
	[ c <= bucket bucketSize ] whileTrue: [ 
		item := bucket at: c.
		bucketIndex := item identityHash \\ buckets size + 1.
		bucketIndex = index
			ifTrue: [ c := c + 1 ]
			ifFalse: [
				(self bucketWithRoomAt: bucketIndex) addNew: item.
				bucket removeAt: c ]]! !

!P4IdentitySet methodsFor: 'removing' stamp: 'ToonVerwaest 8/5/2010 15:55'!
remove: anObject ifAbsent: aBlock
	| bucket value |
	linear ifTrue: [ bucket := buckets at: 1 ]
		ifFalse: [
			bucket := buckets at: anObject identityHash \\ buckets size + 1.
			bucket ifNil: [ ^ aBlock value ]].
	value := bucket remove: anObject ifAbsent: [ ^ aBlock value ].
	self checkShrink.
	^ value! !

!P4Set methodsFor: 'adding' stamp: 'ToonVerwaest 7/23/2011 18:41'!
add: value
	| bucketIndex bucket |
	linear ifTrue: [ ^ self addInFirstBucket: value ].
	
	bucketIndex := (value pHash \\ buckets size) + 1.
	bucket := buckets at: bucketIndex.
	bucket ifNil: [
		bucket := self newBucketAt: bucketIndex.
		bucket addNew: value.
		self checkGrow.
		^ value ].
	(bucket includes: value) ifTrue: [ ^ value ].
	bucket isFull ifTrue: [ bucket := self growBucketAt: bucketIndex ].
	bucket addNew: value.
	self checkGrow.
	^ value
	! !

!P4Set methodsFor: 'adding' stamp: 'ToonVerwaest 7/18/2011 21:43'!
addAll: values
	values do: [ :v | self add: v ]! !

!P4Set methodsFor: 'private' stamp: 'OliFlueckiger 8/5/2011 18:10'!
addInFirstBucket: value
	| bucket |
	bucket := buckets at: 1.
	(bucket includes: value) ifTrue: [ ^ value ].
	bucket isFull ifTrue: [
		size < maxLinear ifFalse: [
			linear := false.
			buckets := Array new: 32.
			self reAddBucket: bucket at: 1.
			^ self add: value ].
		bucket := self growBucketAt: 1 ].
	bucket addNew: value.
	size := size + 1.
	^ value! !

!P4Set methodsFor: 'iterating' stamp: 'ToonVerwaest 7/18/2011 21:35'!
do: aBlock
	self bucketsDo: [ :bucket | bucket do: aBlock ]! !

!P4Set methodsFor: 'testing' stamp: 'ToonVerwaest 7/23/2011 18:41'!
includes: anObject
	linear ifTrue: [ ^ (buckets at: 1) includes: anObject ].
	^ (buckets at: anObject pHash \\ buckets size + 1)
		ifNil: [ false ]
		ifNotNil: [ :bucket | bucket includes: anObject ]! !

!P4Set methodsFor: 'inspecting' stamp: 'ToonVerwaest 8/31/2010 14:21'!
inspectChildrenOn: inspector
	| index |
	index := 0.
	self do: [ :value |
		inspector
			child: (index := index + 1)
			value: [ value ]]! !

!P4Set methodsFor: 'testing' stamp: 'ToonVerwaest 7/18/2011 21:43'!
isEmpty
	^ self size == 0! !

!P4Set methodsFor: 'private' stamp: 'ToonVerwaest 7/18/2011 22:32'!
newBucket: sizeRequested
	<preventExport>
	self flag: 'ne'.
	^ P4SetBucket new: sizeRequested! !

!P4Set methodsFor: 'private' stamp: 'ToonVerwaest 7/23/2011 18:41'!
reAddBucket: bucket at: index
	| c item bucketIndex |
	buckets at: index put: bucket.
	c := 1.
	[ c <= bucket bucketSize ] whileTrue: [ 
		item := bucket at: c.
		bucketIndex := item pHash \\ buckets size + 1.
		bucketIndex = index
			ifTrue: [ c := c + 1 ]
			ifFalse: [
				(self bucketWithRoomAt: bucketIndex) addNew: item.
				bucket removeAt: c ]]! !

!P4Set methodsFor: 'removing' stamp: 'ToonVerwaest 9/6/2010 17:04'!
remove: anObject
	^ self remove: anObject ifAbsent: [ self valueNotFound: anObject ].! !

!P4Set methodsFor: 'removing' stamp: 'ToonVerwaest 7/23/2011 18:41'!
remove: anObject ifAbsent: aBlock
	| bucket value |
	linear ifTrue: [ bucket := buckets at: 1 ]
		ifFalse: [
			bucket := buckets at: anObject pHash \\ buckets size + 1.
			bucket ifNil: [ ^ aBlock value ]].
	value := bucket remove: anObject ifAbsent: [ ^ aBlock value ].
	self checkShrink.
	^ value! !

P4Set subclass: #P4SymbolTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-String'!

!P4SymbolTable methodsFor: 'exporting' stamp: 'OliFlueckiger 7/15/2011 17:20'!
dumpGlobalOn: binaryOut
	^  self dumpOn: binaryOut  ! !

!P4SymbolTable methodsFor: 'exporting' stamp: 'ToonVerwaest 7/23/2011 19:05'!
pExportedName 
	^ #symboltable! !

P4Object subclass: #P4Layout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

P4Layout subclass: #P4LByte
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LByte methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 18:59'!
allocate: memoryManager 
	^ memoryManager allocateByte! !

P4Layout subclass: #P4LLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LLong class methodsFor: 'testing' stamp: 'ToonVerwaest 5/21/2011 18:59'!
isAbstractClass
	self shouldBeImplemented! !

!P4LLong methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 19:00'!
allocate: memoryManager
	^ memoryManager allocateLong! !

P4Layout subclass: #P4LSized
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

P4LSized subclass: #P4LBytes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LBytes methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 19:00'!
allocate: memoryManager
	^ memoryManager allocateBytes: size! !

P4LSized subclass: #P4LPointers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LPointers methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 19:00'!
allocate: memoryManager
	^ memoryManager allocatePointers: size! !

P4LSized subclass: #P4LVariable
	instanceVariableNames: 'extra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LVariable methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 19:01'!
allocate: memoryManager
	^ memoryManager allocatePointers: size variable: extra! !

P4LSized subclass: #P4LWords
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LWords methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 19:01'!
allocate: memoryManager
	^ memoryManager allocateWords: size! !

P4Layout subclass: #P4LWord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

!P4LWord methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 19:01'!
allocate: memoryManager
	^ memoryManager allocateWord! !

!P4Layout methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 18:59'!
allocate: memoryManager
	self subclassResponsibility! !

P4Object subclass: #P4MemoryManager
	instanceVariableNames: 'memory position limit root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Memory'!

!P4MemoryManager methodsFor: 'private' stamp: 'ToonVerwaest 5/24/2011 11:17'!
align: p
	" Align by 2 bytes to keep the last bit free "
	^ (p + 1) bitAnd: -2! !

!P4MemoryManager methodsFor: 'private' stamp: 'ToonVerwaest 5/21/2011 23:36'!
allocate: byteSize
	| result |
	limit - position < byteSize ifTrue: [
		self garbageCollect.
		limit - position < byteSize ifTrue: [
			self extendMemory.
			limit - position < byteSize ifTrue: [
				self outOfMemory ]]].
	result := position.
	position := self align: position + byteSize.
	^ result! !

!P4MemoryManager methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 23:33'!
allocateBytes: size
	| result |
	result := self allocate: size + self headerSize.
	" no pointer, no mark "
	result write: (size << 2 + 2r00).
	^ result + self headerSize! !

!P4MemoryManager methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 18:56'!
allocateClass: aClass
	^ aClass layout allocate: self! !

!P4MemoryManager methodsFor: 'allocation' stamp: 'ToonVerwaest 5/21/2011 23:35'!
allocatePointers: size
	| result |
	result := self allocate: size * self pointerSize + self headerSize.
	" pointer, no mark "
	result write: (size << 2 + 2r10).
	^ result + self headerSize! !

!P4MemoryManager methodsFor: 'private' stamp: 'ToonVerwaest 5/21/2011 19:31'!
extendMemory
	<pNative>! !

!P4MemoryManager methodsFor: 'garbage collection' stamp: 'ToonVerwaest 5/21/2011 22:54'!
garbageCollect
	self mark.
	self sweep.! !

!P4MemoryManager methodsFor: 'garbage collection' stamp: 'ToonVerwaest 5/21/2011 23:08'!
mark
	| current start |
	current := root.
	[ current == start ] whileFalse: [
		current := current markNext nextUnresolvedPointer ]! !

!P4MemoryManager methodsFor: 'garbage collection' stamp: 'ToonVerwaest 5/22/2011 00:07'!
sweep
	| current next |
	current := memory.
	position := memory.
	[ current == limit ] whileFalse: [
		current isMarked
			ifTrue: [
				current == position ifFalse: [ current move: position ].
				position restoreReferences.
				current := current + position size.
				position := position + position size ]
			ifFalse: [ current := current next ]]! !

!P4Object class methodsFor: 'accessing' stamp: 'OliFlueckiger 8/18/2011 13:40'!
earlyClassSelectorAddress: aSelector
	| method |
	method := self pclass pLookupSelector: aSelector.
	^ method earlySelectorAddress.! !

!P4Object class methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:10'!
earlySelectorAddress: aSelector
	"copy in Metaclass"
	| method |
	
	method := self pLookupSelector: aSelector.
	
	^ method earlySelectorAddress.! !

!P4Object class methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 23:05'!
flush
	pname := nil! !

!P4Object class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/19/2011 18:57'!
identityHash
	<preventExport>
	^ super identityHash >> 18! !

!P4Object class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/21/2011 17:23'!
mapToPclass
	^ self! !

!P4Object class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/20/2011 15:47'!
p4class
	^ self class! !

!P4Object class methodsFor: 'accessing' stamp: 'ToonVerwaest 7/18/2011 15:36'!
p4super
	P4Object == self ifTrue: [ ^ nil ].
	^ self superclass! !

!P4Object class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/23/2011 19:15'!
pExportedName 
	^ nil! !

!P4Object class methodsFor: 'accessing' stamp: 'OliFlueckiger 7/28/2011 14:31'!
pHalt
	<preventExport>! !

!P4Object class methodsFor: 'accessing' stamp: 'ToonVerwaest 7/21/2011 17:40'!
pInstanceHeader
	| base variable bytes hash |
	base := self pInstSize.
	variable := self pIsVariable ifTrue: [ 1 ] ifFalse: [ 0 ].
	bytes := self pIsBytes ifTrue: [ 1 ] ifFalse: [ 0 ].
	^ (bytes bitShift: 9) + (variable bitShift: 8) + base! !

!P4Object class methodsFor: 'accessing' stamp: 'ToonVerwaest 5/17/2011 14:50'!
pfullName
	^ (P4Package packageOfClass: self) relativeNameFor: self pname! !

!P4Object class methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 23:04'!
pname
	<preventExport>
	^ pname ifNil: [ pname := (self name copyFrom: 'P4' size + 1 to: self name size) asSymbol ]! !

!P4Object class methodsFor: 'testing' stamp: 'OliFlueckiger 8/18/2011 13:16'!
typeCheckByteSize
	<preventExport>
	(P4SmallInteger inheritsFrom: self) ifTrue: [ ^ 30 ].
	^ 20! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 7/28/2011 20:02'!
= other
	<globalName: #equality>
	^ (self == other)! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 7/28/2011 19:32'!
== other
	" Implemented in the compiler "
	^ self == other! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 8/9/2011 13:11'!
at: key
	<pprimitive: #basicAt>
	^ self basicAt: key  ! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 8/9/2011 13:12'!
at: key put: object
	<pprimitive: #basicAtPut>
	^ self basicAt: key put: object! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:51'!
basicAt: key
	<preventExport>
	^ super basicAt: key! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:53'!
basicAt: key put: object
	<preventExport>
	^ super basicAt: key put: object! !

!P4Object methodsFor: 'class hierarchy' stamp: 'OliFlueckiger 12/7/2011 16:10'!
behavior
	<pprimitive: #behavior> 
	self pHalt.! !

!P4Object methodsFor: 'class hierarchy' stamp: 'OliFlueckiger 12/7/2011 23:01'!
behavior: aBehavior
	<pprimitive: #'set_behavior'> 
	self pHalt.! !

!P4Object methodsFor: 'class hierarchy' stamp: 'OliFlueckiger 8/18/2011 13:51'!
class
	<preventExport>
	^super class! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 9/7/2011 16:51'!
doesNotUnderstand: selector
	<preventExport>
	^ super doesNotUnderstand: selector  ! !

!P4Object methodsFor: 'spec' stamp: 'OliFlueckiger 8/29/2011 18:04'!
expectationFail: got expected: expected
	'expectation not met. got:' print.
	got printObj.
	'but expected:' print.
	expected printObj.
	self pHalt.! !

!P4Object methodsFor: 'spec' stamp: 'OliFlueckiger 7/25/2011 18:33'!
flag: flag! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 12/8/2011 14:43'!
groundedInvoke: selector
	<invoke>
	<globalName: #groundedInvoke>	
	<groundTypes>
	<fixedType: 	#self             		as: #'Kernel.Object.Object'>
	<typeHint: 	#behavior        		as: #'Kernel.Behavior.SmalltalkBehavior'>

	| behavior class method |
	behavior := self behavior.
	method := (behavior lookup: selector for: self).
	^ method perform: selector on: self.! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:58'!
identityHash
	<preventExport>
	^ super identityHash >> 18! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 8/24/2011 16:55'!
ifFalse: aBlock! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 8/29/2011 13:05'!
ifFalse: aFalseBlock ifTrue: aBlock 
	^aBlock value! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 7/22/2011 16:56'!
ifNil: aBlock
	^ aBlock value! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 7/22/2011 16:56'!
ifNil: aBlock ifNotNil: anOtherBlock
	^ anOtherBlock value! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 8/24/2011 16:55'!
ifTrue: aBlock
	^aBlock value! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 8/29/2011 13:04'!
ifTrue: aBlock ifFalse: aFalseBlock
	^aBlock value! !

!P4Object methodsFor: 'initialize-release' stamp: 'OliFlueckiger 7/26/2011 18:24'!
initialize
	<preventExport>
	^super initialize! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 12/7/2011 18:51'!
invoke: selector
	<invoke>
	<globalName: #invoke>	
	<groundTypes>
	<fixedType: 	#self             		as: #'Kernel.Object.Object'>
	<typeHint: 	#behavior        		as: #'Kernel.Behavior.SmalltalkBehavior'>

	| behavior class method |
	behavior := self behavior.
	method := (behavior lookup: selector for: self).
	^ method perform: selector andCacheOn: self.! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 9/7/2011 16:01'!
or: aBlock
	self ifFalse: [ ^aBlock value ]! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 1/6/2012 14:51'!
pBasicAt: key
	<pprimitive: #basicAt>
	<renameExport: #basicAt:>  
	self error: 'Object>>basicAt: failed. this is not an arrayed object'.! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 18:03'!
pBasicAt: key put: object
	<pprimitive: #basicAtPut>
	<renameExport: #basicAt:put:>
	self pHalt! !

!P4Object methodsFor: 'class hierarchy' stamp: 'OliFlueckiger 12/7/2011 16:32'!
pClass
	<renameExport: #class>
	^ self behavior theClass! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 1/9/2012 01:08'!
pDoesNotUnderstand: message
	<renameExport: #doesNotUnderstand:>
	
	'------> does not understand' print.
	self class name print.
	message selector print.
	
	(message arguments size > 0) 
		ifTrue: [ 
			' ------>  arguments: ' print.
			message arguments do: [ :arg |
				arg print ]].
	'<------' print.
	"self pHalt."! !

!P4Object methodsFor: 'spec' stamp: 'CamilloBruni 4/3/2012 15:33'!
pError: string
	<renameExport: #error:>
	string print.
	self pHalt.! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 7/26/2011 17:23'!
pHalt
	<preventExport>! !

!P4Object methodsFor: 'hash' stamp: 'ToonVerwaest 7/23/2011 18:42'!
pHash
	^ self hash! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:58'!
pIdentityHash
	<pprimitive: #identityHash>
	<renameExport: #identityHash>
	self pHalt.  ! !

!P4Object methodsFor: 'initialize-release' stamp: 'OliFlueckiger 7/26/2011 18:25'!
pInitialize
	<renameExport: #initialize>! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 9/13/2011 10:44'!
pInspect 
	self printObj! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 8/18/2011 13:36'!
pLookupSelector: aSelector
	^ self lookupSelector: aSelector! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 1/6/2012 16:10'!
perform: selector with: args
	| behavior method |
	behavior := self behavior.
	method := (behavior lookup: selector for: self).
	^ method perform: selector on: self with: args.! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 9/8/2011 15:14'!
print 
	'a ' print.
	self class name print.! !

!P4Object methodsFor: 'spec' stamp: 'OliFlueckiger 8/5/2011 18:25'!
printObj
	<pprimitive: #'print_object'>
	self pHalt.! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:55'!
psize
	<pprimitive: #size>
	<renameExport: #size>  
	self pHalt.! !

!P4Object methodsFor: 'spec' stamp: 'OliFlueckiger 9/8/2011 14:58'!
shouldBe: sth
	(self = sth) ifFalse: [ self expectationFail: self expected: sth ]  ! !

!P4Object methodsFor: 'testing' stamp: 'OliFlueckiger 8/29/2011 18:03'!
shouldBeTrue
	self expectationFail: self expected: true  ! !

!P4Object methodsFor: 'message handling' stamp: 'OliFlueckiger 7/21/2011 11:53'!
shouldNotCall
	self error: 'my subclass should have overwritten this'! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:57'!
size
	<preventExport>
	^super size! !

!P4Object methodsFor: 'accessing' stamp: 'OliFlueckiger 10/5/2011 17:02'!
yourself
	^ self! !

P4Object subclass: #P4RawCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Memory'!

P4RawCell subclass: #P4ObjectHeader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Memory'!

!P4ObjectHeader methodsFor: 'testing' stamp: 'ToonVerwaest 5/21/2011 21:40'!
hasPointer
	^ (self read bitAnd: 2) = 2! !

!P4ObjectHeader methodsFor: 'testing' stamp: 'ToonVerwaest 5/21/2011 21:40'!
lastPointer
	^ self + self size! !

!P4ObjectHeader methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:39'!
mark
	self write: (self read bitOr: 1)! !

!P4ObjectHeader methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:40'!
size
	^ self read >> 2! !

!P4ObjectHeader methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:40'!
unmark
	self write: (self read bitXor: 1)! !

P4RawCell subclass: #P4ObjectReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Memory'!

!P4ObjectReference methodsFor: 'gc' stamp: 'ToonVerwaest 5/21/2011 23:19'!
markNext
	| header |
	header := self read.
	(header isMarked not and: [ header hasPointer ])
		ifTrue: [ ^ self swapAndDive ].
	^ self swapContinue! !

!P4ObjectReference methodsFor: 'gc' stamp: 'ToonVerwaest 5/21/2011 23:06'!
nextUnresolvedPointer
	| next |
	next := self.
	[ [ next notInSpace ] whileTrue: [ next := next - 1 ].
	next isMarked ] whileTrue: [ next := next read ].
	^ next! !

!P4ObjectReference methodsFor: 'gc' stamp: 'ToonVerwaest 5/21/2011 23:20'!
restoreReferences
	| current next |
	current := self read.
	[ current unmark.
	   next := current read.
	  current hasPointer ]
		whileFalse: [
			current write: self.
			current := next ].
	self write: next.
	current write: self.! !

!P4ObjectReference methodsFor: 'gc' stamp: 'ToonVerwaest 5/21/2011 23:21'!
swapAndDive
	| header next |
	header := self read.
	next := header next.
	next := next - next headerSize.
	self write: header.
	header write: self.
	^ next! !

!P4ObjectReference methodsFor: 'gc' stamp: 'ToonVerwaest 5/21/2011 23:07'!
swapContinue
	| header |
	header := self read.
	self write: header.
	header write: self.
	^ self - 1! !

!P4RawCell methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:52'!
+ number
	<pNative: #plus module: #Memory>! !

!P4RawCell methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:52'!
- number
	<pNative: #minus module: #Memory>! !

!P4RawCell methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:53'!
>> number
	<pNative: #shiftRight module: #Memory>! !

!P4RawCell methodsFor: 'testing' stamp: 'ToonVerwaest 5/21/2011 21:51'!
isMarked
	^ (self read bitAnd: 1) = 1! !

!P4RawCell methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:38'!
read
	<pNative: #read module: #Memory>! !

!P4RawCell methodsFor: 'accessing' stamp: 'ToonVerwaest 5/21/2011 21:38'!
write: aValue
	<pNative: #write module: #Memory>! !

P4Object subclass: #P4Slot
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Structure'!

P4Object subclass: #P4SmallInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Number'!

!P4SmallInteger class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/23/2011 19:12'!
pExportedName 
	^ self == P4SmallInteger
		ifTrue: [ #SmallInteger ]
		ifFalse: [ super pExportedName ]! !

!P4SmallInteger class methodsFor: 'exporting' stamp: 'OliFlueckiger 8/18/2011 13:10'!
typeCheckByteSize
	<preventExport>
	^ 10! !

!P4SmallInteger class methodsFor: 'exporting' stamp: 'OliFlueckiger 7/22/2011 17:54'!
typeHints 
	<preventExport>
	^ { #self -> #'Kernel.Number.SmallInteger' } asDictionary! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/28/2011 13:31'!
* anObject
	<pprimitive: #mult>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 16:46'!
+ anObject
	<pprimitive: #plus>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 16:47'!
- anObject
	<pprimitive: #minus>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/6/2011 14:49'!
// anObject
	<pprimitive: #intDivide>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 16:46'!
< anObject
	<pprimitive: #smaller>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 16:46'!
<= anObject
	<pprimitive: #smallerEqual>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/6/2011 14:50'!
> anObject
	<pprimitive: #bigger>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/5/2011 18:59'!
\\ anObject
	<pprimitive: #modulo>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 16:46'!
bitShift: n
	<pprimitive: #bitShift>
	self pHalt.! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 10/4/2011 15:52'!
hash
	^ self ! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/8/2011 15:16'!
print
	self printObj ! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 13:00'!
to: end by: step do: aBlock
	| nextValue |
	nextValue := self.
	[nextValue <= end]
		whileTrue: 
			[aBlock value: nextValue.
			nextValue := nextValue + step]! !

!P4SmallInteger methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/22/2011 18:01'!
to: end do: aBlock
	| nextValue |
	nextValue := self.
	[nextValue <= end]
		whileTrue: 
			[aBlock value: nextValue.
			nextValue := nextValue + 1]! !

P4Object subclass: #P4SmalltalkBehavior
	instanceVariableNames: 'methodDictionary class superbehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Behavior'!

P4SmalltalkBehavior class
	instanceVariableNames: 'instance'!

P4SmalltalkBehavior class
	instanceVariableNames: 'instance'!

!P4SmalltalkBehavior class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 12/7/2011 16:42'!
for: aClass
	^ self new setClass: aClass ! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 18:15'!
dumpGlobalOn: bo
	^ self dumpOn: bo! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 18:06'!
dumpLocalOn: bo
	^ bo postpone: self  ! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:46'!
initialize 
	methodDictionary := P4MethodDictionary new! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 15:54'!
installMethod: aMethod  
	methodDictionary at: aMethod selector put: aMethod ! !

!P4SmalltalkBehavior methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 12/7/2011 19:25'!
lookup: selector for: object
	<groundTypes>
	<typeHint: #methods 	as: #'Kernel.Behavior.MethodDictionary'>
	<typeHint: #behavior 	as: #'Kernel.Behavior.SmalltalkBehavior'>

	| methods behavior |
	behavior := self.
	[ behavior == nil ] whileFalse: [
		methods := behavior methodDictionary.
		(methods at: selector) 
			ifNotNil: [ :method | ^ method ].
		behavior := behavior superbehavior ].
	
	^ P4DoesNotUnderstand new! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 15:51'!
methodDictionary
	^ methodDictionary! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 15:51'!
methodDictionary: anObject
	methodDictionary := anObject! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 18:04'!
pExportedName 
	<preventExport>
	^ (self theClass pExportedName, '_behavior') asSymbol ! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 17:04'!
setClass: aClass
	class := aClass! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:04'!
superbehavior 
	^ superbehavior ! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:28'!
superbehavior: aBehavior
	superbehavior := aBehavior! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:32'!
superclass 
	^ superbehavior 
		ifNil: [ nil ]
		ifNotNil: [ superbehavior theClass ]! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:38'!
superclass: aClass
	aClass 
		ifNil: [ superbehavior := nil ]
		ifNotNil: [ superbehavior := aClass theBehavior ]! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:32'!
theBehavior
	^ self! !

!P4SmalltalkBehavior methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 16:33'!
theClass
	^ class! !

P4Object variableByteSubclass: #P4String
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-String'!

!P4String methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/29/2011 06:32'!
print
	<pprimitive: #print>
	self pHalt.! !

P4String variableByteSubclass: #P4Symbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-String'!

!P4Symbol class methodsFor: 'exporting' stamp: 'ToonVerwaest 7/23/2011 19:13'!
pExportedName 
	^ self == P4Symbol
		ifTrue: [ #Symbol ]
		ifFalse: [ super pExportedName ]! !

!P4Symbol methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 15:05'!
countArgs
	<pprimitive: #'count_args'>
	self pHalt! !

P4Object subclass: #P4UndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-Kernel-Object'!

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/24/2011 16:55'!
ifFalse: aBlock
	^ aBlock value  ! !

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 13:05'!
ifFalse: aFalseBlock ifTrue: aBlock 
	^aFalseBlock value! !

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/22/2011 16:57'!
ifNil: aBlock
	^ aBlock value! !

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/22/2011 16:57'!
ifNil: aBlock ifNotNil: anOtherBlock
	^ aBlock value! !

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/24/2011 16:55'!
ifTrue: aBlock
! !

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 13:05'!
ifTrue: aBlock  ifFalse: aFalseBlock
	^aFalseBlock value! !

!P4UndefinedObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/10/2011 18:02'!
value
	^ nil! !
